#!/usr/bin/perl -w
#
#  $Id: parseHmmGenes.pl,v 1.2 2007/10/16 23:20:20 whuang Exp $
#  fastHmm/fastBlast Alignment Tools
#  http://microbesonline.org/fasthmm (fasthmm@microbesonline.org)
#
#  Script for parsing hmmsearch output into tab-delimited list of hits
#
#  Copyright (C) 2007 The Regents of the University of California
#  All rights reserved.
#
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2 of the License, or
#  (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License along
#  with this program; if not, write to the Free Software Foundation, Inc.,
#  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
#
#  Disclaimer
#
#  NEITHER THE UNITED STATES NOR THE UNITED STATES DEPARTMENT OF ENERGY,
#  NOR ANY OF THEIR EMPLOYEES, MAKES ANY WARRANTY, EXPRESS OR IMPLIED,
#  OR ASSUMES ANY LEGAL LIABILITY OR RESPONSIBILITY FOR THE ACCURACY,
#  COMPLETENESS, OR USEFULNESS OF ANY INFORMATION, APPARATUS, PRODUCT,
#  OR PROCESS DISCLOSED, OR REPRESENTS THAT ITS USE WOULD NOT INFRINGE
#  PRIVATELY OWNED RIGHTS.
#

die "Usage: ParseHmmGenes.pl HmmName < hmmsearch >> genesfile" if @ARGV != 1;

my $acc = $ARGV[0];
while(<STDIN>) {
    last if m/^Scores for complete/;
}

while(<STDIN>) {
    chomp;
    last if m/^Parsed for domains/ || m/^[ \t]+.?no hits/;
    next if $_ eq "" || m/^Sequence +Description/ || m/^[ -]+$/;
    my @F = split /[\t ]+/, $_;
    die "Cannot parse $_" unless @F==4;
    print join("\t",$acc,$F[0],$F[1],$F[2])."\n";
}
